#include "fractions.h"
#include <stdio.h>
#include <math.h>


// Function implementations
void display_fraction(struct Fraction frac) {

    printf("%d/%d ", frac.numerator,frac.denominator);

}
int calculate_gcd(int a, int b) {
    int gcd, remainder;

    if (a < 0) a = -a;
    if (b < 0) b = -b;

    while (b != 0) {
        remainder = a % b;
        a = b;
        b = remainder;
    }

    gcd = a;

    return gcd;

}

struct Fraction reduce_fraction(struct Fraction frac) {
     
     int gcd = calculate_gcd(frac.denominator,frac.numerator);

    if (gcd != 0) {  // Ensure the denominator is not zero before dividing
        frac.denominator /= gcd;
        frac.numerator /= gcd;
    }
    return frac;
}



struct Fraction power_fraction(struct Fraction base, int exponent) {

    if (base.numerator <= 0 || exponent < 0) {
        printf("Invalid input: numerator or exponent is non-positive.\n");
        return base;
    }

    base.denominator = pow(base.denominator,exponent);
    base.numerator = pow(base.numerator,exponent);

    return base;
}
void  fraction_add_inplace(struct Fraction *result, const struct Fraction *fraction1, const struct Fraction *fraction2) {
    // Add fractions: (a/b) + (c/d) = (ad + bc) / bd

    result->denominator = fraction1->denominator * fraction2->denominator;
    result->numerator = (fraction1->numerator*  fraction2->denominator) + (fraction1->denominator*fraction2->numerator);
    

    *result = reduce_fraction(*result);

}
void fraction_sub_inplace(struct Fraction *result, const struct Fraction *fraction1, const struct Fraction *fraction2) {
    // sub fractions: (a/b) - (c/d) = (ad - bc) / bd

    result->denominator = fraction1->denominator * fraction2->denominator;
    result->numerator = (fraction1->numerator*  fraction2->denominator) - (fraction1->denominator*fraction2->numerator);



    *result = reduce_fraction(*result);


}


// ... other function implementations ...
