#include <stdio.h>
#include <math.h>

struct Fraction {
    double numerator;
    double denominator;
};

// Tolerance for considering a floating-point number as zero
#define EPSILON 1e-9

struct Fraction power_fraction(struct Fraction base, int exponent) {
    if (fabs(base.numerator) < EPSILON || exponent < 0) {
        printf("Invalid input: numerator is zero or exponent is non-positive.\n");
        return base;
    }

    // Handle negative exponent
    if (exponent < 0) {
        double temp = base.numerator;
        base.numerator = base.denominator;
        base.denominator = temp;

        base.denominator = pow(base.denominator, -exponent);
        base.numerator = pow(base.numerator, -exponent);
    } else {
        // Positive exponent
        base.denominator = pow(base.denominator, exponent);
        base.numerator = pow(base.numerator, exponent);
    }

    return base;
}

void display_fraction(struct Fraction frac) {
    printf("%lf/%lf\n", frac.numerator, frac.denominator);
}

int main() {
    struct Fraction myfraction = {20.0, 6.0};

    printf("Original fraction: ");
    display_fraction(myfraction);

    // Raise the fraction to the power of -2
    myfraction = power_fraction(myfraction, -2);

    printf("Fraction after raising to the power of -2: ");
    display_fraction(myfraction);

    return 0;
}
