

typedef enum _error_code {
ok, err
} error_code;

typedef struct _matrix {
int m, n;
int ** data;
} matrix;

typedef struct _pgm {
int max;
matrix pixels;
} pgm;


// pGM functions
error_code pgm_read_from_file(pgm *p, char *filename);

error_code pgm_write_to_file(pgm *p, char *filename);

error_code pgm_negative(pgm *neg, pgm *orig);


error_code pgm_symmetry_hori(pgm *sym, pgm *orig);

//error_code pgm_crop(pgm *crop, pgm *orig,int32_t x0, int32_t x1, int32_t y0, int32_t y1);


// matrix functions

error_code matrix_alloc(matrix *mat, int m, int n);

error_code matrix_init(matrix *mat, int m, int n, int val);

error_code matrix_destroy(matrix *mat);

error_code matrix_init_from_array(matrix *mat, int m, int n,int* data);

error_code matrix_clone(matrix *cloned, matrix mat);

error_code matrix_print(matrix mat);

error_code matrix_get(int *elem, matrix mat, int ix, int iy);

error_code matrix_set(matrix mat, int ix, int iy, int elem);

// Read and write to files functions