
typedef struct {
    struct entry_t **entries;
    int length;
} hm_t;

typedef struct entry_t {
    char *key;
    char *value;
    struct entry_t *next;
}entry_t;

// création d'un pointeur vers une hm
hm_t* hm_create(int capacity);
// destruction de la hm et libération de la mémoire
void hm_destroy(hm_t* hm);
// insère la paire key-value dans la hm. si key est déjà présente
// écraser value dans la hm. La clé et la valeur sont stockées
// dans de nouveau espaces mémoires alloués par la fonction

void hm_set(hm_t* hm, char* key, char* value);
// retourne la valeur associé à la clé, key
// dans un espace mémoire alloué à strcet effet
char* hm_get_alloc(hm_t* hm, char* key);
// retourne la valeur associé à la clé, key
// retourne le pointeur dans la structure hm_t
char* hm_get(hm_t* hm, char* key);
// retire une clé de la hm
void hm_rm(hm_t* hm, char* key);
// teste si une clé se trouve dans la hm
bool hm_is_present(hm_t* hm, char* key);
// affiche le contenu de la hm
void hm_print(hm_t* hm);
// sauvegarde les pairs clé-valeur contenues de la table de hachage dans un fichier texte
// au format <key>;<value>
void hm_save(hm_t *hm, char *filename);
// charge les pairs clé-valeur dans une table de hachage depuis les
// lignes d'un fichier texte dont le format est <key>;<value>
hm_t *hm_load(char *filename);