#include <stdio.h>
#include <stdlib.h>

int get_max(int n, const int* tab) {
    int max = tab[0];
    for (int i = 1; i < n; i++) {
        if (tab[i] > max) {
            max = tab[i];
        }
    }
    return max;
}

int **dilatation(int m, int n, const int** tab) {
    int **res = malloc(m * sizeof(int*));
    for (int i = 0; i < m; i++) {
        res[i] = malloc(n * sizeof(int));
        for (int j = 0; j < n; j++) {
            int max[5];
            int k = 0;  // Start k from 1

            max[k] = tab[i][j];
            k += 1;

            if (i > 0) {
                max[k++] = tab[i - 1][j];  // Use tab[i-1][j] for the top element
            }

            if (i < m - 1) {
                max[k++] = tab[i + 1][j];  // Use tab[i+1][j] for the bottom element
            }

            if (j > 0) {
                max[k++] = tab[i][j - 1];  // Use tab[i][j-1] for the left element
            }

            if (j < n - 1) {
                max[k++] = tab[i][j + 1];  // Use tab[i][j+1] for the right element
            }

            res[i][j] = get_max(k, max);
        }
    }
    return res;  // Do not free(res) here
}

void print_tab(int m, int n, const int** tab) {
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            printf("%d ", tab[i][j]);
        }
        printf("\n");
    }
    printf("\n");
}

int **init_array(int m, int n) {
    int **res = malloc(m * sizeof(int*));
    int k = 1;
    for (int i = 0; i < m; i++) {
        res[i] = malloc(n * sizeof(int));
        for (int j = 0; j < n; j++) {
            res[i][j] = k++;
        }
    }
    return res;  // Do not free(res) here
}

int main() {
    int m = 5, n = 5;
    int **tab = init_array(m, n);

    print_tab(m, n, (const int**)tab);

    int** res = dilatation(m, n, (const int **)tab);

    print_tab(m, n, (const int**)res);

    // Free memory
    for (int i = 0; i < m; i++) {
        free(tab[i]);
        free(res[i]);
    }
    free(tab);
    free(res);

    return 0;
}
